      program matriz
      
      integer n,i,j,k
      parameter(n=6)
      real*8 a(n,n),inv(n,n),b(n),det
      
      
      
      call mat(n,a)
      write(*,*) 'Matriz a'
      do i=1,n
        write(*,'(6(f9.6))') (a(i,j) ,j=1,n)
      enddo
      pause
      call lu(n,a)
      write(*,*) 'Matriz L'
      do i=1,n
        write(*,'(6(f12.7))') (a(i,j), j=1,i)
      enddo
      write(*,*) 'Matriz U'
      do i=1,n
        write(*,'(6(f12.7))') (a(i,j), j=i+1,n)
      enddo    
      pause
      do j=1,n
         do i=1,n
           b(i)=0
         enddo
        b(j)=1
        call solve(n,a,b)
        do i=1,n
          inv(i,j)=b(i)
        enddo
        if(j.eq.n) then 
        write(*,*) 'Inversa'
        do i=1,n
        write(*,'(6(f12.7))') (inv(i,k) ,k=1,n)
        enddo
        pause
        endif
      enddo 
      
      det=1
      do j=1,n
        det=det*a(j,j)
      enddo
      write(*,*) 'determinante ',det
      
      end
      
      subroutine mat(n,a)
      
      integer n
      real*8 a(n,n),i,j
      
      do i=1,n
        do j=1,n
          if (j.gt.i) then
            a(i,j)=3**(i-j)
           endif
            if (j.eq.i) then
              a(i,j)=(1/i)
            endif
             if (j.lt.i) then
             a(i,j)=(4**j)/(4**i)
          endif
                          
        enddo
        
      enddo
        
      return
      
      end
      
      subroutine lu(n,a)
      
      integer n,i,j,k,l
      real*8 a(n,n)
      
        do j=2,n
          a(1,j)=a(1,j)/a(1,1)
        enddo
      do k=2,n-1
          do i=k,n
            do l=1,k-1
              a(i,k)=a(i,k)-a(i,l)*a(l,k)
            enddo
          enddo
                
        do j=k+1,n
          do l=1,k-1
            a(k,j)=a(k,j)-a(k,l)*a(l,j)
          enddo  
            a(k,j)=a(k,j)/a(k,k)
        enddo
      enddo  
      
      do l=1,n-1
        a(n,n)=a(n,n)-a(n,l)*a(l,n)
      enddo
      
      return
      
      end
      
      subroutine solve(n,a,b)
      
      integer n,i,l
      real*8 a(n,n),b(n)
      
      b(1)=b(1)/a(1,1)
      
      do i=2,n
        do l=1,i-1
          b(i)=b(i)-a(i,l)*b(l)
        enddo
        b(i)=b(i)/a(i,i)
      enddo
      
      do i=n-1,1,-1
        do l=i+1,n
          b(i)=b(i)-a(i,l)*b(l)
        enddo
      enddo
      
      end             