      program sistema
      
      integer i,j,k,m,z
      real*8 n,inv(10,10),a(100,100),b(100),norm0,norm1
      open(20,file='resul3.doc',status='unknown')
      z=1
      dowhile(z.ne.3)
      
      write(*,*) 'Elija una opcion'
      write(*,*) '1. Calculo de la inversa y el determinante, para n=6'
      write(*,*) '2. Calculo del sistema Ax=b, para n=10,20,30,40,50'
      write(*,*) '(Pulse 3 para finalizar)'
      read(*,*) z
            
      if(z.eq.1) then
       n=6
       m=1
       call mat(n,m,a)
       call lu(n,a)
      
      do j=1,n
         do i=1,n
           b(i)=0
         enddo
        b(j)=1
        call solve(n,a,b)
        do i=1,n
          inv(i,j)=b(i)
        enddo
        if(j.eq.n) then 
        write(*,*) 'Inversa' 
        write(20,*) 'Inversa'
        do i=1,n
        write(*,'(6(e13.6))') (inv(i,k) ,k=1,n)     
        write(20,'(6(e13.6))') (inv(i,k) ,k=1,n)
        enddo
        pause
        endif
      enddo 
      
      else if(z.eq.2) then
      
      do j=1,2
      
      do n=10,50,10
        call mat(n,j,a)
        call coef(n,b)
        call lu(n,a)
        call solve(n,a,b)
      
        if(n.eq.10) then
          write(*,*) 'Soluciones para n=10'    
          write(20,*) 'Soluciones para n=10'
          write(20,*)
          do i=1,n
            write(*,'(f20.16)') b(i)
            write(20,'(f20.16)') b(i)
          enddo
          pause
        endif
          norm0=0
        do i=1,n
          norm1=abs(b(i)-1)
          if(norm1.ge.norm0) then
            norm0=norm1
          endif
        enddo
      
      write(*,'(a7,f4.1,a1)') 'norma(',n,')'
      write(*,'(e15.7)') norm0           
      write(20,'(a7,f4.1,a1)') 'norma(',n,')'
      write(20,'(e15.7)') norm0
      pause
      enddo
            
      enddo
      
      endif
      enddo 
      close(20)
      end
      
            
      subroutine mat(n,k,a)
            
      real*8 n,a(n,n),i,j
      integer k
      do i=1,n
        do j=1,n
          if (j.gt.i) then
            a(i,j)=3**(i-j)
           endif
            if (j.eq.i) then
              a(i,j)=(1/i)
            endif
             if (j.lt.i) then
             a(i,j)=(4**j)/(4**i)
          endif
           
        enddo
        
      enddo 
        if(k.eq.2) then
          a(n,n)=1.0001/n
        endif
        if(n.eq.6) then
          write(*,*) 'Matriz A'
          write(20,*) 'Matriz A'
          do i=1,n
            write(*,'(6(e13.6))') (a(i,j) ,j=1,n)      
            write(20,'(6(e13.6))') (a(i,j) ,j=1,n)
          enddo
          pause
        endif
      return
      
      end
      
      subroutine coef(n,b)
      
      real*8 n,b(n),i
      
      b(1)=1.5*(1-3**(-n))
      
      do i=2,n-1
        b(i)=1/i+(1-3**(i-n))/2+(1-4**(1-i))/3
       
      enddo
      b(n)=1/n+(1-4**(1-n))/3
      
      
      return
      
      end
      
      subroutine lu(n,a)
      
      integer i,j,k,l
      real*8 det,n,a(n,n)
      
        do j=2,n
          a(1,j)=a(1,j)/a(1,1)
        enddo
      do k=2,n-1
          do i=k,n
            do l=1,k-1
              a(i,k)=a(i,k)-a(i,l)*a(l,k)
            enddo
          enddo
                
        do j=k+1,n
          do l=1,k-1
            a(k,j)=a(k,j)-a(k,l)*a(l,j)
          enddo  
            a(k,j)=a(k,j)/a(k,k)
          
        enddo
      enddo  
      
      do l=1,n-1
        a(n,n)=a(n,n)-a(n,l)*a(l,n)
      enddo
      if(n.eq.6) then
        write(*,*) 'Matriz LU'
        write(20,*) 'Matriz LU'
        do i=1,n
          write(*,'(6(e13.6))') (a(i,j), j=1,n)
          write(20,'(6(e13.6))') (a(i,j), j=1,n)
        enddo
        pause
        
        det=1
        do j=1,n
          det=det*a(j,j)
        enddo
        write(*,*) 'determinante ',det 
        write(20,*) 'determinante ',det
        pause
      endif
      return
      
      end
      
      subroutine solve(n,a,b)
      
      integer i,l
      real*8 n,a(n,n),b(n)
      
      b(1)=b(1)/a(1,1)
      
      do i=2,n
        do l=1,i-1
          b(i)=b(i)-a(i,l)*b(l)
        enddo
        b(i)=b(i)/a(i,i)
      enddo
      
      do i=n-1,1,-1
        do l=i+1,n
          b(i)=b(i)-a(i,l)*b(l)
        enddo
      enddo
      
      end                